package Source::Shared::Resource::DestDistroInfo;

use strict;
use warnings;
use Carp;

use DistroMap 0.39;
use Source::Shared::Resource;
use Source::Shared::ResourceContainer;
our @ISA=qw/Source::Shared::Resource/;

push @Source::Shared::ResourceContainer::RESOURCE_CLASSES, __PACKAGE__;

our $VERSION=0.001;
our $verbose=0;
# set in SourceAnalyzer Transformation
our $opt_check_distrodb;
## TODO:
# 1) make a single place DistroMap/Resource::DistroMap/Resource::DistroInfo
#    defaults to set and command line options to select a repo/branch (in DistroMap?)
#    (shared or wrapped by DestDistroInfo).
#    It possibly need a redesign of DistroMap (
#       like a method to get dest repo should be a static method of DistroInfo
#       and new DistroMap should be a lazy call independent of dest repo 
#       and using dest repo if it is already exist.
# 2) move this altlinux/sisyphus defaults to proper places (Convert and BundleImport)
my $opt_destrepo='altlinux';
my $opt_destbranch='sisyphus';

my $__distroinfo;

sub process_options {
    my ($self)=@_;
    # if we have get_dest_distroinfo from the package Source::Shared::Resource::DistroMap
    if(*Source::Shared::ResourceContainer::get_dest_distroinfo{CODE}) {
	$DistroMap::opt_dest_check_distrodb//=$opt_check_distrodb;
    } else {
	*Source::Shared::ResourceContainer::get_dest_distroinfo=\&get_dest_distroinfo;
    }
}

sub get_dest_distroinfo {
    return $__distroinfo if $__distroinfo;
    $__distroinfo=DistroMap::Repository->new(
	-repo=>$opt_destrepo, 
	-branch=>$opt_destbranch,
	-check_distrodb => $opt_check_distrodb,
	);
    return $__distroinfo;
}

1;
