package Source::Shared::Resource::DistroMap;

use strict;
use warnings;
use Carp;

use DistroMap 0.39;
use Source::Shared::Resource;
use Source::Shared::ResourceContainer;
our @ISA=qw/Source::Shared::Resource/;

push @Source::Shared::ResourceContainer::RESOURCE_CLASSES, __PACKAGE__;

our $VERSION=0.001;
our $verbose=0;

sub cli_container_ref {
    return ['DistroMap'];
}

my $__distromap;

package Source::Shared::ResourceContainer;

use strict;
use warnings;

sub get_distromap {
    return $__distromap if $__distromap;
    $__distromap=DistroMap->new();
    print STDERR "get_distromap: created distromap\n" if $Source::Shared::Resource::DistroMap::verbose>1;
    return $__distromap;
}

# note: get_dest_distroinfo is also provided by
# Source::Shared::Resource::DestDistroInfo
sub get_dest_distroinfo {
    return &get_distromap->dest();
}

# TODO: make a separate resource (for now, only used in shared libs converter)
sub get_origin_distroinfo {
    return &get_distromap->origin();
}


1;
