package Source::Shared::ResourceContainer;

use strict;
use warnings;

our $VERSION=0.002;

use Source::Shared::Resource;
use Source::Shared::CLI 0.006;
our @ISA=qw/Source::Shared::CLI/;

our @RESOURCE_CLASSES;
BEGIN {
 @RESOURCE_CLASSES=qw//;
}

our $pass_through_mode;
our @PASS_THROUGH_OPTS;
our $verbose;
my @__pass_through_refs;


my $_shared_self;

sub get_resourceobj {
    my $class=shift;
    $_shared_self=__PACKAGE__->new() unless $_shared_self;
    return $_shared_self;
}


sub cli_container_ref {
    my ($self)=@_;
    return \@RESOURCE_CLASSES;
}

sub get_longopt {
    my ($self)=@_;
    return if __PACKAGE__->_check_called('__get_longopt');
    my @longopt=map {$_->get_longopt} @{$self->cli_container_ref};
    return @longopt unless $pass_through_mode;
    my @retval;
    my $count=0;
    $#__pass_through_refs=(scalar @longopt)/2;
    while (@longopt) {
	my $optspec=shift @longopt;
	my $optref=shift @longopt;
	$__pass_through_refs[$count]=$optref;
	my $anonsub;
	if (ref ($optref) eq 'ARRAY') {
	    eval '$anonsub=sub {push @PASS_THROUGH_OPTS, q{--}.$_[0],$_[1]; push @{$__pass_through_refs['.$count.']}, $_[1];}' or die "$@";
	} elsif (ref ($optref) eq 'HASH') {
	    eval '$anonsub=sub {push @PASS_THROUGH_OPTS, q{--}.$_[0],$_[1],$_[2]; $__pass_through_refs['.$count.']->{$_[1]}=$_[2];}' or die "$@";
	} elsif (ref ($optref) eq 'CODE') {
	    eval '$anonsub=sub {push @PASS_THROUGH_OPTS, q{--}.$_[0],$_[1]; push @PASS_THROUGH_OPTS, $_[2] if defined($_[2]); &{$__pass_through_refs['.$count.']}($_[0],$_[1],$_[2]);}' or die "$@";
	} elsif (ref ($optref) eq 'SCALAR') {
	    eval '$anonsub=sub {push @PASS_THROUGH_OPTS, q{--}.$_[0],$_[1]; ${$__pass_through_refs['.$count.']}=$_[1];}' or die "$@";
	} else {
	    die "unsupported optref $optref";
	}
	print STDERR "ResourceContainer: got opt: $optspec -> $anonsub\n" if $verbose;
	push @retval, $optspec, $anonsub;
	$count++;
    }
    return @retval;
}

1;
